from asdl import pybase

option_t = int  # type alias for integer

class option_i(object):
  errexit = 1
  nounset = 2
  pipefail = 3
  inherit_errexit = 4
  nullglob = 5
  verbose_errexit = 6
  noexec = 7
  xtrace = 8
  verbose = 9
  noglob = 10
  noclobber = 11
  errtrace = 12
  posix = 13
  vi = 14
  emacs = 15
  interactive = 16
  hashall = 17
  lastpipe = 18
  failglob = 19
  extglob = 20
  nocasematch = 21
  eval_unsafe_arith = 22
  ignore_flags_not_impl = 23
  ignore_shopt_not_impl = 24
  _allow_command_sub = 25
  _allow_process_sub = 26
  dynamic_scope = 27
  redefine_const = 28
  redefine_source = 29
  _running_trap = 30
  _running_hay = 31
  _no_debug_trap = 32
  _no_err_trap = 33
  strict_parse_slice = 34
  strict_argv = 35
  strict_arith = 36
  strict_array = 37
  strict_control_flow = 38
  strict_errexit = 39
  strict_nameref = 40
  strict_word_eval = 41
  strict_tilde = 42
  strict_glob = 43
  no_copy_env = 44
  parse_at = 45
  parse_proc = 46
  parse_func = 47
  parse_brace = 48
  parse_bracket = 49
  parse_equals = 50
  parse_paren = 51
  parse_ysh_string = 52
  parse_triple_quote = 53
  simple_word_eval = 54
  dashglob = 55
  command_sub_errexit = 56
  process_sub_fail = 57
  xtrace_rich = 58
  xtrace_details = 59
  sigpipe_status_ok = 60
  env_obj = 61
  parse_at_all = 62
  parse_backslash = 63
  parse_backticks = 64
  parse_dollar = 65
  parse_ignored = 66
  parse_sh_arith = 67
  parse_dparen = 68
  parse_dbracket = 69
  parse_bare_word = 70
  simple_echo = 71
  simple_eval_builtin = 72
  simple_test_builtin = 73
  expand_aliases = 74
  progcomp = 75
  histappend = 76
  hostcomplete = 77
  cmdhist = 78
  assoc_expand_once = 79
  autocd = 80
  cdable_vars = 81
  cdspell = 82
  checkhash = 83
  checkjobs = 84
  checkwinsize = 85
  complete_fullquote = 86
  direxpand = 87
  dirspell = 88
  dotglob = 89
  execfail = 90
  extdebug = 91
  extquote = 92
  force_fignore = 93
  globasciiranges = 94
  globstar = 95
  gnu_errfmt = 96
  histreedit = 97
  histverify = 98
  huponexit = 99
  interactive_comments = 100
  lithist = 101
  localvar_inherit = 102
  localvar_unset = 103
  login_shell = 104
  mailwarn = 105
  no_empty_cmd_completion = 106
  nocaseglob = 107
  progcomp_alias = 108
  promptvars = 109
  restricted_shell = 110
  shift_verbose = 111
  sourcepath = 112
  xpg_echo = 113
  ARRAY_SIZE = 114

_option_str = {
  1: 'option.errexit',
  2: 'option.nounset',
  3: 'option.pipefail',
  4: 'option.inherit_errexit',
  5: 'option.nullglob',
  6: 'option.verbose_errexit',
  7: 'option.noexec',
  8: 'option.xtrace',
  9: 'option.verbose',
  10: 'option.noglob',
  11: 'option.noclobber',
  12: 'option.errtrace',
  13: 'option.posix',
  14: 'option.vi',
  15: 'option.emacs',
  16: 'option.interactive',
  17: 'option.hashall',
  18: 'option.lastpipe',
  19: 'option.failglob',
  20: 'option.extglob',
  21: 'option.nocasematch',
  22: 'option.eval_unsafe_arith',
  23: 'option.ignore_flags_not_impl',
  24: 'option.ignore_shopt_not_impl',
  25: 'option._allow_command_sub',
  26: 'option._allow_process_sub',
  27: 'option.dynamic_scope',
  28: 'option.redefine_const',
  29: 'option.redefine_source',
  30: 'option._running_trap',
  31: 'option._running_hay',
  32: 'option._no_debug_trap',
  33: 'option._no_err_trap',
  34: 'option.strict_parse_slice',
  35: 'option.strict_argv',
  36: 'option.strict_arith',
  37: 'option.strict_array',
  38: 'option.strict_control_flow',
  39: 'option.strict_errexit',
  40: 'option.strict_nameref',
  41: 'option.strict_word_eval',
  42: 'option.strict_tilde',
  43: 'option.strict_glob',
  44: 'option.no_copy_env',
  45: 'option.parse_at',
  46: 'option.parse_proc',
  47: 'option.parse_func',
  48: 'option.parse_brace',
  49: 'option.parse_bracket',
  50: 'option.parse_equals',
  51: 'option.parse_paren',
  52: 'option.parse_ysh_string',
  53: 'option.parse_triple_quote',
  54: 'option.simple_word_eval',
  55: 'option.dashglob',
  56: 'option.command_sub_errexit',
  57: 'option.process_sub_fail',
  58: 'option.xtrace_rich',
  59: 'option.xtrace_details',
  60: 'option.sigpipe_status_ok',
  61: 'option.env_obj',
  62: 'option.parse_at_all',
  63: 'option.parse_backslash',
  64: 'option.parse_backticks',
  65: 'option.parse_dollar',
  66: 'option.parse_ignored',
  67: 'option.parse_sh_arith',
  68: 'option.parse_dparen',
  69: 'option.parse_dbracket',
  70: 'option.parse_bare_word',
  71: 'option.simple_echo',
  72: 'option.simple_eval_builtin',
  73: 'option.simple_test_builtin',
  74: 'option.expand_aliases',
  75: 'option.progcomp',
  76: 'option.histappend',
  77: 'option.hostcomplete',
  78: 'option.cmdhist',
  79: 'option.assoc_expand_once',
  80: 'option.autocd',
  81: 'option.cdable_vars',
  82: 'option.cdspell',
  83: 'option.checkhash',
  84: 'option.checkjobs',
  85: 'option.checkwinsize',
  86: 'option.complete_fullquote',
  87: 'option.direxpand',
  88: 'option.dirspell',
  89: 'option.dotglob',
  90: 'option.execfail',
  91: 'option.extdebug',
  92: 'option.extquote',
  93: 'option.force_fignore',
  94: 'option.globasciiranges',
  95: 'option.globstar',
  96: 'option.gnu_errfmt',
  97: 'option.histreedit',
  98: 'option.histverify',
  99: 'option.huponexit',
  100: 'option.interactive_comments',
  101: 'option.lithist',
  102: 'option.localvar_inherit',
  103: 'option.localvar_unset',
  104: 'option.login_shell',
  105: 'option.mailwarn',
  106: 'option.no_empty_cmd_completion',
  107: 'option.nocaseglob',
  108: 'option.progcomp_alias',
  109: 'option.promptvars',
  110: 'option.restricted_shell',
  111: 'option.shift_verbose',
  112: 'option.sourcepath',
  113: 'option.xpg_echo',
}

def option_str(val):
  # type: (option_t) -> str
  return _option_str[val]

builtin_t = int  # type alias for integer

class builtin_i(object):
  colon = 1
  dot = 2
  exec_ = 3
  eval = 4
  set = 5
  shift = 6
  times = 7
  trap = 8
  unset = 9
  readonly = 10
  local = 11
  declare = 12
  typeset = 13
  export_ = 14
  extern_ = 15
  true_ = 16
  false_ = 17
  try_ = 18
  assert_ = 19
  read = 20
  echo = 21
  printf = 22
  mapfile = 23
  readarray = 24
  cd = 25
  pushd = 26
  popd = 27
  dirs = 28
  pwd = 29
  source = 30
  umask = 31
  ulimit = 32
  wait = 33
  jobs = 34
  fg = 35
  bg = 36
  shopt = 37
  complete = 38
  compgen = 39
  compopt = 40
  compadjust = 41
  compexport = 42
  getopts = 43
  builtin = 44
  command = 45
  type = 46
  hash = 47
  help = 48
  history = 49
  alias = 50
  unalias = 51
  bind = 52
  append = 53
  write = 54
  json = 55
  json8 = 56
  pp = 57
  hay = 58
  haynode = 59
  use = 60
  error = 61
  failed = 62
  fork = 63
  forkwait = 64
  redir = 65
  fopen = 66
  shvar = 67
  ctx = 68
  invoke = 69
  runproc = 70
  boolstatus = 71
  test = 72
  bracket = 73
  push_registers = 74
  source_guard = 75
  is_main = 76
  cat = 77
  ARRAY_SIZE = 78

_builtin_str = {
  1: 'builtin.colon',
  2: 'builtin.dot',
  3: 'builtin.exec_',
  4: 'builtin.eval',
  5: 'builtin.set',
  6: 'builtin.shift',
  7: 'builtin.times',
  8: 'builtin.trap',
  9: 'builtin.unset',
  10: 'builtin.readonly',
  11: 'builtin.local',
  12: 'builtin.declare',
  13: 'builtin.typeset',
  14: 'builtin.export_',
  15: 'builtin.extern_',
  16: 'builtin.true_',
  17: 'builtin.false_',
  18: 'builtin.try_',
  19: 'builtin.assert_',
  20: 'builtin.read',
  21: 'builtin.echo',
  22: 'builtin.printf',
  23: 'builtin.mapfile',
  24: 'builtin.readarray',
  25: 'builtin.cd',
  26: 'builtin.pushd',
  27: 'builtin.popd',
  28: 'builtin.dirs',
  29: 'builtin.pwd',
  30: 'builtin.source',
  31: 'builtin.umask',
  32: 'builtin.ulimit',
  33: 'builtin.wait',
  34: 'builtin.jobs',
  35: 'builtin.fg',
  36: 'builtin.bg',
  37: 'builtin.shopt',
  38: 'builtin.complete',
  39: 'builtin.compgen',
  40: 'builtin.compopt',
  41: 'builtin.compadjust',
  42: 'builtin.compexport',
  43: 'builtin.getopts',
  44: 'builtin.builtin',
  45: 'builtin.command',
  46: 'builtin.type',
  47: 'builtin.hash',
  48: 'builtin.help',
  49: 'builtin.history',
  50: 'builtin.alias',
  51: 'builtin.unalias',
  52: 'builtin.bind',
  53: 'builtin.append',
  54: 'builtin.write',
  55: 'builtin.json',
  56: 'builtin.json8',
  57: 'builtin.pp',
  58: 'builtin.hay',
  59: 'builtin.haynode',
  60: 'builtin.use',
  61: 'builtin.error',
  62: 'builtin.failed',
  63: 'builtin.fork',
  64: 'builtin.forkwait',
  65: 'builtin.redir',
  66: 'builtin.fopen',
  67: 'builtin.shvar',
  68: 'builtin.ctx',
  69: 'builtin.invoke',
  70: 'builtin.runproc',
  71: 'builtin.boolstatus',
  72: 'builtin.test',
  73: 'builtin.bracket',
  74: 'builtin.push_registers',
  75: 'builtin.source_guard',
  76: 'builtin.is_main',
  77: 'builtin.cat',
}

def builtin_str(val):
  # type: (builtin_t) -> str
  return _builtin_str[val]

